"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var vue_1 = tslib_1.__importDefault(require("vue"));
var createReduxStore_1 = require("../core/utils/createReduxStore");
var target = typeof window !== 'undefined'
    ? window
    : typeof global !== 'undefined' ? global : {};
// @ts-ignore
var devtoolHook = target.__VUE_DEVTOOLS_GLOBAL_HOOK__;
var changed = [];
var unsubscribe;
var devtoolSubscribe;
var devtoolPlugin = function (store) {
    if (!devtoolHook) {
        return;
    }
    var hookStore = {};
    var originalState = store.getState();
    Object.defineProperty(hookStore, 'state', {
        get: function () {
            return store.getState();
        }
    });
    Object.defineProperty(hookStore, 'getters', {
        get: function () {
            return {};
        }
    });
    devtoolHook.emit('vuex:init', hookStore);
    // FIXME: How to travel in redux?
    // devtoolHook.on('vuex:travel-to-state', (targetState) => {
    //   store.replaceState(targetState)
    // });
    if (devtoolSubscribe) {
        devtoolSubscribe();
    }
    devtoolSubscribe = store.subscribe(function () {
        var currentState = store.getState();
        if (originalState !== currentState) {
            // FIXME: Compute diff patch
            devtoolHook.emit('vuex:mutation', { type: 'dev' });
        }
    });
};
exports.reducerChanged = function (reducerName, value) {
    changed.push([reducerName, value]);
};
exports.createReduxStore = function (config) {
    var store = createReduxStore_1.createReduxStore(config);
    var vm = new vue_1.default({
        data: {
            state: store.getState(),
        },
    });
    devtoolPlugin(store);
    if (unsubscribe) {
        unsubscribe();
    }
    // The first subscription
    unsubscribe = store.subscribe(function () {
        var nextState = store.getState();
        if (changed.length) {
            changed.forEach(function (item) {
                vm.state[item[0]] = item[1];
            });
            changed = [];
        }
        if (nextState !== vm.state) {
            vm.state = nextState;
        }
    });
    return store;
};
